#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import os


if len(sys.argv) == 1:
	sys.argv += ['m','1']

if int(sys.argv[2]) == 1:
	subs = "ortho"
else:
	subs = "meta_para"

list_file = open("/home/bates/pka/benzoic_acids/list_" + subs)

for line in list_file:
	line = line.rstrip()
	charge_file = open(line + "." + sys.argv[1] + "chrg")
	pka = open("/home/bates/pka/benzoic_acids/corina_" + subs + "/" + line + ".pka").read().rstrip()

	data = os.popen("/home/bates/benzoic_acids/ids.py ../" + line + ".sdf").read().rstrip().split(';')
	
	smiles = open("/home/bates/pka/benzoic_acids/smiles_" + subs + "/" + line + ".smi").read().split()[0]

	atom_number = -2	

	for chrg in charge_file:
		atom_number += 1
		chrg = chrg.rstrip()
		if atom_number == int(data[0]):
			C1_charge = chrg.split()[2]

		elif atom_number == int(data[1]):
			O1_charge = chrg.split()[2]

		elif atom_number == int(data[2]):
			O2_charge = chrg.split()[2]

		elif atom_number == int(data[3]):
			H_charge = chrg.split()[2]
	
	print line + ";" + smiles + ";" + pka + ";" + data[0] + ";"  + C1_charge + ";" + data[1] + ";" + O1_charge + ";" + data[2] + ";" + O2_charge + ";" + data[3] + ";" + H_charge

