#!/usr/bin/python

# benzoic_acids.py
import sys

def getSymbols(array):
        ret = []
        for elem in array:
                ret.append(elem[0])
        return ret

def getChildren(array):
	ret = []
	for elem in array:
		ret += elem[2]
	return ret

line_number = 0
elements_length = 0
bond_count = 0
elements = []

sdfile = open(sys.argv[1])

for line in sdfile:
	line_number += 1
	
	if line_number == 4:
		elements_length = int(line.split()[0])
		bond_count = int(line.split()[1])
	
	elif line_number > 4 and line_number - 5 < elements_length:
		elements.append([line.split()[3], line_number - 4, []])	
	
	elif line_number - 5 < elements_length + bond_count and line_number > 4:
		elements[int(line.split()[0]) - 1][2] += [elements[int(line.split()[1]) - 1]]
		elements[int(line.split()[1]) - 1][2] += [elements[int(line.split()[0]) - 1]]

sdfile.close()

#print "--------"
#for elem in elements:
#	print elem[0] + ' ' + str(getSymbols(elem[2]))
#print "--------"

oxygen1 = 0
oxygen2 = 0
carbon = 0
hydrogen = 0

for element in elements:
	if element[0] == 'C' and sorted(getSymbols(element[2])) == ['C','O','O']:
		for s1 in element[2]:
			if s1[0] == 'O' and sorted(getSymbols(s1[2])) == ['C', 'H']:
				oxygen2 = s1[1]
				for s2 in s1[2]:
                                        if s2[0] == 'C':
                                                carbon = s2[1]
                                        elif s2[0] == 'H':
                                                hydrogen = s2[1]
				for s3 in element[2]:
					if s3[0] == 'O' and getSymbols(s3[2]) == ['C']:
						oxygen1 = s3[1]

							
print str(carbon) + ';' + str(oxygen1) + ';' + str(oxygen2) + ';' + str(hydrogen)
