
set output "graph.eps"
set term postscript eps size 7, 7
infile = "plotinput.csv"
set termoption enhanced
set encoding cp1250

set title graph_title font "Helvetica, 48" offset 0, 5
set xlabel "Experimentln pK_a\n" font "Helvetica, 48" textcolor rgb "#696969" offset 0, 6
set ylabel "Vypoten pK_a" font "Helvetica, 48" textcolor rgb "#696969" offset 11, 0

set datafile separator ";"
set decimalsign "."

set size square
set border lw 3
set xtics font "Helvetica, 36" offset -0.5, -0.7
set ytics font "Helvetica, 36" offset -0.3, 0

lm=0.13
m=0.1

set lmargin at screen 0+lm
set rmargin at screen 1.0-lm
set bmargin at screen 0.0+m
set tmargin at screen 1-m

plot [x:y] [x:y] infile using 1:2 notitle with point pt 7 lc rgb "black" ps 2
